/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mappings are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2004 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package jorm;

import org.objectweb.jorm.naming.api.PBinder;
import org.objectweb.jorm.naming.api.PExceptionNaming;
import org.objectweb.jorm.api.PExceptionProtocol;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.naming.api.PName;
import org.objectweb.jorm.naming.api.PNameCoder;
import org.objectweb.jorm.api.PSerializable;
import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PAccessorGen;
import org.objectweb.jorm.api.PClassMapping;

public class JE2_ReservationSerializable implements PSerializable, JE2_ReservationAccessor {

	//the pname of the object
	protected String pName;
	
		protected java.lang.Integer JONASAUTOPKFIELD;
			protected double amountPaid;
			protected  String cabins;
			protected  String cruise;
			protected  String customers;
			protected java.util.Date date;
	
	public String setPName(PName pName){
		if(pName.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				this.pName  = pName.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			this.pName = "null";
		}
		return this.pName;
	}
	
	public PName getPName(PBinder pnc) throws PExceptionNaming{
		try{
			return pnc.decodeString(pName);
		}catch (Exception e) {
              throw new PExceptionNaming("Cannot decode to a PName: " + e.getMessage());
        }
	}
	
	public String getClassName(){
		return "jorm.JE2_Reservation";
	}
	

	public void paSetJONASAUTOPKFIELD(java.lang.Integer val){
		JONASAUTOPKFIELD = val;
	}
	public java.lang.Integer paGetJONASAUTOPKFIELD() {
		return JONASAUTOPKFIELD;
	}

	public void paSetAmountPaid(double val){
		amountPaid = val;
	}
	public double paGetAmountPaid() {
		return amountPaid;
	}

	public void paSetCabins(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				cabins = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			cabins = "null";
		}
	}
	
	public PName paGetCabins(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("cabins");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(cabins);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetCruise(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				cruise = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			cruise = "null";
		}
	}
	
	public PName paGetCruise(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("cruise");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(cruise);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetCustomers(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				customers = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			customers = "null";
		}
	}
	
	public PName paGetCustomers(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("customers");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(customers);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetDate(java.util.Date val){
		date = val;
	}
	public java.util.Date paGetDate() {
		return date;
	}

	public Object getMemoryInstance(){
		return this;
	}
	
	
	public String toString(){
		StringBuffer s = new StringBuffer();
		s.append("data(");
					s.append(JONASAUTOPKFIELD + ",  ");
					s.append(amountPaid + ",  ");
					s.append(cabins + ",  ");
					s.append(cruise + ",  ");
					s.append(customers + ",  ");
					s.append(date + ",  ");
				s.append(pName + ")");
		return s.toString();
	}
	
	
	public void read(PClassMapping pcm, PAccessor pa) throws PException{
		JE2_ReservationAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PException("Accessor must not be null");
		else if (pa instanceof JE2_ReservationAccessor)
			paccessor = (JE2_ReservationAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PException("Wrong type of accessor: " + pa);
	 	try {	
			if(paccessor != null){
											paccessor.paSetJONASAUTOPKFIELD(paGetJONASAUTOPKFIELD());
															paccessor.paSetAmountPaid(paGetAmountPaid());
															paccessor.paSetCabins(paGetCabins(pcm), null);
															paccessor.paSetCruise(paGetCruise(pcm), null);
															paccessor.paSetCustomers(paGetCustomers(pcm), null);
															paccessor.paSetDate(paGetDate());
							 			}
 			else{
	  		 			        		//paccessorGen.paSetOintField("JONASAUTOPKFIELD", paGetJONASAUTOPKFIELD(pcm), null);
	        			 			        		//paccessorGen.paSetDoubleField("amountPaid", paGetAmountPaid(pcm), null);
	        			 						 						 						 			        		//paccessorGen.paSetDateField("date", paGetDate(pcm), null);
	        			        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
	
	public void write(PClassMapping pcm, PAccessor pa) throws PException{
		JE2_ReservationAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PExceptionProtocol("Accessor must not be null");
		else if (pa instanceof JE2_ReservationAccessor)
			paccessor = (JE2_ReservationAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PExceptionProtocol("Wrong type of accessor: " + pa);
		try {	
			if(paccessor != null){
											paSetJONASAUTOPKFIELD(paccessor.paGetJONASAUTOPKFIELD());
															paSetAmountPaid(paccessor.paGetAmountPaid());
															paSetCabins(paccessor.paGetCabins(pcm), null);
															paSetCruise(paccessor.paGetCruise(pcm), null);
															paSetCustomers(paccessor.paGetCustomers(pcm), null);
															paSetDate(paccessor.paGetDate());
							 			}
 			else{
	  		 				        	//	paSetOintField(JONASAUTOPKFIELD, paccessorGen.paGetJONASAUTOPKFIELD());
        		//paSetOintField("JONASAUTOPKFIELD", paccessorGen.paGetOintField("JONASAUTOPKFIELD"));
        		//paSetJONASAUTOPKFIELD(paccessorGen.paGetOintField("JONASAUTOPKFIELD"), null);
	        			 				        	//	paSetDoubleField(amountPaid, paccessorGen.paGetAmountPaid());
        		//paSetDoubleField("amountPaid", paccessorGen.paGetDoubleField("amountPaid"));
        		//paSetAmountPaid(paccessorGen.paGetDoubleField("amountPaid"), null);
	        			 						 						 						 				        	//	paSetDateField(date, paccessorGen.paGetDate());
        		//paSetDateField("date", paccessorGen.paGetDateField("date"));
        		//paSetDate(paccessorGen.paGetDateField("date"), null);
	        			        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
}